import fcntl
from ctypes import *
import types

class amdgpuv_vf_info_t(Structure):
    _pack_=1
    _fields_=[("identifier",c_char * 64),\
    ("funcID",c_int),\
    ("vfBDF",c_char * 8),\
    ("vfFBSize",c_ulonglong),\
    ("vfStatus",c_uint)]
    pass


class amdgpuv_device_info_t(Structure):
    _pack_=1
    _fields_=[("identifier",c_char * 64),\
    ("deviceID",c_uint),\
    ("pfBDF",c_char * 8),\
    ("pfFBSize",c_ushort),\
    ("vfCount",c_uint),\
    ("schedIntv",c_ulonglong),\
    ("vfInfo",amdgpuv_vf_info_t * 16)]


if __name__=='__main__':
    fd=open('/dev/vmgfx32','r+')
    deviceinfo=amdgpuv_device_info_t()
    fcntl.ioctl(fd,7,deviceinfo)
    print deviceinfo.identifier
    print '%s,%d,%d,%Ld'%(deviceinfo.pfBDF,deviceinfo.pfFBSize,deviceinfo.vfCount,deviceinfo.schedIntv)
    for vf in deviceinfo.vfInfo:
        print '%s'%(vf.identifier)
